<?php
$functions = array(
    'joomdle_user_id' => array(         //web service function name
        'classname'   => 'joomdle_helpers_external',  //class containing the external function
        'methodname'  => 'user_id',          //external function name
        'classpath'   => 'auth/joomdle/helpers/externallib.php',  //file containing the class/external function
        'description' => 'Get user id.',    //human readable description of the web service function
        'type'        => 'read',                  //database rights of the web service function (read, write)
    ),
    'joomdle_list_courses' => array(         //web service function name
        'classname'   => 'joomdle_helpers_external',  //class containing the external function
        'methodname'  => 'list_courses',          //external function name
        'classpath'   => 'auth/joomdle/helpers/externallib.php',  //file containing the class/external function
        'description' => 'List courses',    //human readable description of the web service function
        'type'        => 'read',                  //database rights of the web service function (read, write)
    ),
    'joomdle_my_courses' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'my_courses', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get user courses', 
        'type'        => 'read',                 
    ),
    'joomdle_get_course_info' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_course_info', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get course info', 
        'type'        => 'read',                 
    ),
    'joomdle_get_course_contents' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_course_contents', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get course topics', 
        'type'        => 'read',                 
    ),
    'joomdle_courses_by_category' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'courses_by_category', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get courses from a category', 
        'type'        => 'read',                 
    ),
    'joomdle_get_course_categories' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_course_categories', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get course categories', 
        'type'        => 'read',                 
    ),
    'joomdle_get_course_editing_teachers' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_course_editing_teachers', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get course editing teachers', 
        'type'        => 'read',                 
    ),
    'joomdle_get_course_no' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_course_no', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get number of courses', 
        'type'        => 'read',                 
    ),
    'joomdle_get_enrollable_course_no' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_enrollable_course_no', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get number of enrollable courses', 
        'type'        => 'read',                 
    ),
    'joomdle_get_student_no' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_student_no', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get number of students', 
        'type'        => 'read',                 
    ),
    'joomdle_get_total_assignment_submissions' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_total_assignment_submissions', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get number of submitted assignments', 
        'type'        => 'read',                 
    ),
    'joomdle_get_course_students_no' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_course_students_no', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get number of students in a course', 
        'type'        => 'read',                 
    ),
    'joomdle_get_assignment_submissions' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_assignment_submissions', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get course submitted assignments', 
        'type'        => 'read',                 
    ),
    'joomdle_get_assignment_grades' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_assignment_grades', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get assignments grades', 
        'type'        => 'read',                 
    ),
    'joomdle_get_upcoming_events' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_upcoming_events', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get upcoming events', 
        'type'        => 'read',                 
    ),
    'joomdle_get_news_items' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_news_items', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get news', 
        'type'        => 'read',                 
    ),
    'joomdle_get_user_grades' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_user_grades', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get user grades in a course', 
        'type'        => 'read',                 
    ),
    'joomdle_get_course_grade_categories' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_course_grade_categories', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get  grades categories of course', 
        'type'        => 'read',                 
    ),
    'joomdle_search_courses' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'search_courses', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Search courses', 
        'type'        => 'read',                 
    ),
    'joomdle_search_categories' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'search_categories', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Search course categories', 
        'type'        => 'read',                 
    ),
    'joomdle_search_topics' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'search_topics', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Search course topics', 
        'type'        => 'read',                 
    ),
    'joomdle_get_my_courses_grades' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_my_courses_grades', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get user grades', 
        'type'        => 'read',                 
    ),
    'joomdle_check_moodle_users' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'check_moodle_users', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Check usernames for moodle accounts', 
        'type'        => 'read',                 
    ),
    'joomdle_get_moodle_only_users' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_moodle_only_users', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get users existing only in moodle', 
        'type'        => 'read',                 
    ),
    'joomdle_get_moodle_users' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_moodle_users', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get moodle users', 
        'type'        => 'read',                 
    ),
    'joomdle_get_moodle_users_number' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_moodle_users_number', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get moodle users', 
        'type'        => 'read',                 
    ),
    'joomdle_user_exists' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'user_exists', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Check if username exists', 
        'type'        => 'read',                 
    ),
    'joomdle_create_joomdle_user' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'create_joomdle_user', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Creates user account', 
        'type'        => 'read',                 
    ),
    'joomdle_enrol_user' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'enrol_user', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Enrols user into course', 
        'type'        => 'read',                 
    ),
    'joomdle_user_details' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'user_details', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get user details', 
        'type'        => 'read',                 
    ),
    'joomdle_user_details_by_id' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'user_details_by_id', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get user details', 
        'type'        => 'read',                 
    ),
    'joomdle_migrate_to_joomdle' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'migrate_to_joomdle', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get user details', 
        'type'        => 'read',                 
    ),
    'joomdle_my_events' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'my_events', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get user events', 
        'type'        => 'read',                 
    ),
    'joomdle_delete_user' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'delete_user', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get user events', 
        'type'        => 'read',                 
    ),
    'joomdle_get_mentees' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_mentees', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get user mentees', 
        'type'        => 'read',                 
    ),
    'joomdle_get_roles' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_roles', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get roles', 
        'type'        => 'read',                 
    ),
    'joomdle_get_parents' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_parents', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get roles', 
        'type'        => 'read',                 
    ),
    'joomdle_get_site_last_week_stats' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_site_last_week_stats', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get site stats', 
        'type'        => 'read',                 
    ),
    'joomdle_get_course_daily_stats' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_course_daily_stats', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get course stats', 
        'type'        => 'read',                 
    ),
    'joomdle_get_last_user_grades' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_last_user_grades', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get course stats', 
        'type'        => 'read',                 
    ),
    'joomdle_system_check' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'system_check', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Joomdle system check', 
        'type'        => 'read',                 
    ),
    'joomdle_add_parent_role' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'add_parent_role', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Adds parent role', 
        'type'        => 'read',                 
    ),
    'joomdle_get_paypal_config' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_paypal_config', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get paypal config', 
        'type'        => 'read',                 
    ),
    'joomdle_update_session' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'update_session', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Updates user session', 
        'type'        => 'read',                 
    ),
    'joomdle_get_cat_name' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'get_cat_name', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get category name', 
        'type'        => 'read',                 
    ),
    'joomdle_courses_abc' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'courses_abc', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get course list for courses starting with chars', 
        'type'        => 'read',                 
    ),
    'joomdle_teachers_abc' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'teachers_abc', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get teachers list for teacher names starting with chars', 
        'type'        => 'read',                 
    ),
    'joomdle_teacher_courses' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'teacher_courses', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get courses teached by user', 
        'type'        => 'read',                 
    ),
    'joomdle_user_custom_fields' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'user_custom_fields', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get custom fields', 
        'type'        => 'read',                 
    ),
    'joomdle_course_enrol_methods' => array(        
        'classname'   => 'joomdle_helpers_external',
        'methodname'  => 'course_enrol_methods', 
        'classpath'   => 'auth/joomdle/helpers/externallib.php',
        'description' => 'Get course available enrolment methods', 
        'type'        => 'read',                 
    ),
);

?>
