<?php

require_once("$CFG->libdir/externallib.php");
require_once($CFG->dirroot.'/auth/joomdle/auth.php');
 
class joomdle_helpers_external extends external_api {
 
	/* user_id */
    public static function user_id_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'multilang compatible name, course unique'),
                        )
        );
    }

    public static function user_id_returns() {
        return new  external_value(PARAM_INT, 'multilang compatible name, course unique');
    }

    public static function user_id($username) { //Don't forget to set it as static
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::user_id_parameters(), array('username'=>$username));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->user_id ($username);

        return $id;
    }

    
	/* list_courses */
    public static function list_courses_parameters() {
        return new external_function_parameters(
                        array(
                            'enrollable_only' => new external_value(PARAM_INT, 'Return only enrollable courses'),
                            'sortby' => new external_value(PARAM_TEXT, 'Order field'),
                            'guest' => new external_value(PARAM_INT, 'Return only courses for guests'),
                        )
        );
    }

    public static function list_courses_returns() {
		 return new external_multiple_structure(
            new external_single_structure(
                array(
                    'remoteid' => new external_value(PARAM_INT, 'course id'),
                    'cat_id' => new external_value(PARAM_INT, 'category id'),
                    'cat_name' => new external_value(PARAM_TEXT, 'cartegory name'),
                    'cat_description' => new external_value(PARAM_RAW, 'category description'),
                    'sortorder' => new external_value(PARAM_TEXT, 'sortorder'),
                    'fullname' => new external_value(PARAM_TEXT, 'course name'),
                    'shortname' => new external_value(PARAM_TEXT, 'course shortname'),
                    'idnumber' => new external_value(PARAM_RAW, 'idnumber'),
                    'summary' => new external_value(PARAM_RAW, 'summary'),
                    'startdate' => new external_value(PARAM_INT, 'start date'),
                    'created' => new external_value(PARAM_INT, 'created'),
                    'modified' => new external_value(PARAM_INT, 'modified'), 
                )
            )
        );
    }

    public static function list_courses($enrrollable_only, $sortby, $guest) { //Don't forget to set it as static
        global $CFG, $DB;
 
      $params = self::validate_parameters(self::list_courses_parameters(), array('enrollable_only'=>$enrollable_only, 'sortby' => $sortby,'guest' => $guest)); 
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->list_courses ($enrrollable_only, $sortby, $guest);

        return $id;
    }

	/* test */
    public static function test_parameters() {
        return new external_function_parameters(
                        array(
                        )
        );
    }

    public static function test_returns() {
		 return  new external_value(PARAM_TEXT, 'test data');
    }

    public static function test() { //Don't forget to set it as static
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::test_parameters(), array());
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->test ();

        return $return;
    }

	/* my_courses */
    public static function my_courses_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'Username'),
                        )
        );
    }

    public static function my_courses_returns() {
		 return new external_multiple_structure(
            new external_single_structure(
                array(
                    'id' => new external_value(PARAM_INT, 'group record id'),
                    'fullname' => new external_value(PARAM_TEXT, 'course name'),
                )
            )
        );
    }

    public static function my_courses($username) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::my_courses_parameters(), array('username'=>$username));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->my_courses ($username);

        return $return;
    }


	/* get_course_info */
    public static function get_course_info_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_course_info_returns() {
            return new external_single_structure(
                array(
                    'remoteid' => new external_value(PARAM_INT, 'course id'),
                    'cat_id' => new external_value(PARAM_INT, 'category id'),
                    'cat_name' => new external_value(PARAM_TEXT, 'category name'),
                    'cat_description' => new external_value(PARAM_RAW, 'category description'),
                    'sortorder' => new external_value(PARAM_TEXT, 'category name'),
                    'fullname' => new external_value(PARAM_TEXT, 'course name'),
                    'shortname' => new external_value(PARAM_TEXT, 'course name'),
                    'idnumber' => new external_value(PARAM_RAW, 'category name'),
                    'summary' => new external_value(PARAM_RAW, 'summary'),
                    'startdate' => new external_value(PARAM_INT, 'start date'),
                    'numsections' => new external_value(PARAM_INT, 'number of sections'),
                    'lang' => new external_value(PARAM_RAW, 'lang'),
                    'cost' => new external_value(PARAM_FLOAT, 'cost', VALUE_OPTIONAL),
                    'currency' => new external_value(PARAM_TEXT, 'currency', VALUE_OPTIONAL),
                    'enrolstartdate' => new external_value(PARAM_INT, 'enrol start date', VALUE_OPTIONAL), 
                    'enrolenddate' => new external_value(PARAM_INT, 'enrol end date', VALUE_OPTIONAL), 
                )
            );
    }

    public static function get_course_info($id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_course_info_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_course_info ($id);


        return $return;
    }

	/* get_course_contents */
    public static function get_course_contents_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_course_contents_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'section' => new external_value(PARAM_INT, 'section id'),
						'summary' => new external_value(PARAM_RAW, 'summary'),
					)
				)
            );
    }

    public static function get_course_contents($id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_course_contents_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_course_contents ($id);


        return $return;
    }

	/* courses_by_category */
    public static function courses_by_category_parameters() {
        return new external_function_parameters(
                        array(
                            'category' => new external_value(PARAM_INT, 'category id'),
                            'enrollable_only' => new external_value(PARAM_INT, 'Return only enrollable courses'),
                        )
        );
    }

    public static function courses_by_category_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'remoteid' => new external_value(PARAM_INT, 'course id'),
						'cat_id' => new external_value(PARAM_INT, 'category id'),
						'cat_name' => new external_value(PARAM_TEXT, 'category name'),
						'cat_description' => new external_value(PARAM_RAW, 'category description'),
						'fullname' => new external_value(PARAM_TEXT, 'course name'),
						'summary' => new external_value(PARAM_RAW, 'course summary'),
					)
				)
            );
    }

    public static function courses_by_category($category, $enrollable_only) {
        global $CFG, $DB;
 
//        $params = self::validate_parameters(self::courses_by_category_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->courses_by_category ($category, $enrollable_only);


        return $return;
    }


	/* get_course_categories */
    public static function get_course_categories_parameters() {
        return new external_function_parameters(
                        array(
                            'category' => new external_value(PARAM_INT, 'category id'),
                        )
        );
    }

    public static function get_course_categories_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'id' => new external_value(PARAM_INT, 'category id'),
						'name' => new external_value(PARAM_TEXT, 'category name'),
						'description' => new external_value(PARAM_RAW, 'description'),
					)
				)
            );
    }

    public static function get_course_categories($category) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_course_categories_parameters(), array('category'=>$category));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_course_categories ($category);


        return $return;
    }

	/* get_course_editing_teachers */
    public static function get_course_editing_teachers_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_course_editing_teachers_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'firstname' => new external_value(PARAM_TEXT, 'firstname'),
						'lastname' => new external_value(PARAM_TEXT, 'lastname'),
					)
				)
            );
    }

    public static function get_course_editing_teachers($id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_course_editing_teachers_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_course_editing_teachers ($id);


        return $return;
    }


	/* get_course_no */
    public static function get_course_no_parameters() {
        return new external_function_parameters(
                        array(
                        )
        );
    }

    public static function get_course_no_returns() {
        return new  external_value(PARAM_INT, 'number of courses');
    }

    public static function get_course_no() {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_course_no_parameters(), array());
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_course_no ();


        return $return;
    }

	/* get_enrollable_course_no */
    public static function get_enrollable_course_no_parameters() {
        return new external_function_parameters(
                        array(
                        )
        );
    }

    public static function get_enrollable_course_no_returns() {
        return new  external_value(PARAM_INT, 'number of courses');
    }

    public static function get_enrollable_course_no() {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_enrollable_course_no_parameters(), array());
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_enrollable_course_no ();


        return $return;
    }


	/* get_student_no */
    public static function get_student_no_parameters() {
        return new external_function_parameters(
                        array(
                        )
        );
    }

    public static function get_student_no_returns() {
        return new  external_value(PARAM_INT, 'number of students');
    }

    public static function get_student_no() {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_student_no_parameters(), array());
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_student_no ();


        return $return;
    }

	/* get_total_assignment_submissions */
    public static function get_total_assignment_submissions_parameters() {
        return new external_function_parameters(
                        array(
                        )
        );
    }

    public static function get_total_assignment_submissions_returns() {
        return new  external_value(PARAM_INT, 'number of submitted assingments');
    }

    public static function get_total_assignment_submissions() {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_total_assignment_submissions_parameters(), array());
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_total_assignment_submissions ();


        return $return;
    }


	/* get_course_student_no */
    public static function get_course_students_no_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_course_students_no_returns() {
        return new  external_value(PARAM_INT, 'number of submitted assingments');
    }

    public static function get_course_students_no($id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_course_students_no_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_course_students_no ($id);


        return $return;
    }

	/* get_assignment_submissions */
    public static function get_assignment_submissions_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_assignment_submissions_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'id' => new external_value(PARAM_INT, 'id'),
						'tarea' => new external_value(PARAM_TEXT, 'task'),
						'entregados' => new external_value(PARAM_INT, 'submitted'),
					)
				)
            );
    }

    public static function get_assignment_submissions($id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_assignment_submissions_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_assignment_submissions ($id);


        return $return;
    }

	/* get_assignment_grades */
    public static function get_assignment_grades_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_assignment_grades_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'tarea' => new external_value(PARAM_TEXT, 'task'),
						'media' => new external_value(PARAM_FLOAT, 'submitted'),
					)
				)
            );
    }

    public static function get_assignment_grades($id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_assignment_grades_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_assignment_grades ($id);


        return $return;
    }


	/* get_upcoming_events */
    public static function get_upcoming_events_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_upcoming_events_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'name' => new external_value(PARAM_TEXT, 'event name'),
						'timestart' => new external_value(PARAM_INT, 'start time'),
						'courseid' => new external_value(PARAM_INT, 'course id'),
					)
				)
            );
    }

    public static function get_upcoming_events($id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_upcoming_events_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_upcoming_events ($id);


        return $return;
    }

	/* get_news_items */
    public static function get_news_items_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_news_items_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'discussion' => new external_value(PARAM_INT, 'discussion id'),
						'subject' => new external_value(PARAM_TEXT, 'subject'),
						'timemodified' => new external_value(PARAM_INT, 'timemodified'),
					)
				)
            );
    }

    public static function get_news_items($id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_news_items_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_news_items ($id);


        return $return;
    }

	/* get_user_grades */
    public static function get_user_grades_parameters() {
        return new external_function_parameters(
                        array(
                            'user' => new external_value(PARAM_TEXT, 'username'),
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_user_grades_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'itemname' => new external_value(PARAM_TEXT, 'item name'),
						'finalgrade' => new external_value(PARAM_TEXT, 'final grade'),
					)
				)
            );
    }

    public static function get_user_grades($user, $id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_user_grades_parameters(), array('user' => $user, 'id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_user_grades ($user, $id);


        return $return;
    }


	/* get_course_grade_categories */
    public static function get_course_grade_categories_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_course_grade_categories_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'fullname' => new external_value(PARAM_TEXT, 'item name'),
						'grademax' => new external_value(PARAM_TEXT, 'final grade'),
					)
				)
            );
    }

    public static function get_course_grade_categories($id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_course_grade_categories_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_course_grade_categories ($id);


        return $return;
    }

	/* search_courses */
   public static function search_courses_parameters() {
        return new external_function_parameters(
                        array(
                            'text' => new external_value(PARAM_TEXT, 'text to search'),
                            'phrase' => new external_value(PARAM_TEXT, 'search type'),
                            'ordering' => new external_value(PARAM_TEXT, 'order'),
                            'limit' => new external_value(PARAM_TEXT, 'limit'),
                        )
        );
    }

    public static function search_courses_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'remoteid' => new external_value(PARAM_INT, 'course id'),
						'cat_id' => new external_value(PARAM_INT, 'category id'),
						'cat_name' => new external_value(PARAM_TEXT, 'category name'),
						'cat_description' => new external_value(PARAM_RAW, 'category description'),
						'sortorder' => new external_value(PARAM_TEXT, 'category name'),
						'fullname' => new external_value(PARAM_TEXT, 'course name'),
						'shortname' => new external_value(PARAM_TEXT, 'course name'),
						'idnumber' => new external_value(PARAM_RAW, 'category name'),
						'summary' => new external_value(PARAM_RAW, 'summary'),
						'startdate' => new external_value(PARAM_INT, 'start date'),
					)
				)
            );
    }
    public static function search_courses($text, $phrase, $ordering, $limit) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::search_courses_parameters(), array('text'=>$text, 'phrase'=>$phrase, 'ordering'=>$ordering, 'limit'=>$limit));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->search_courses ($text, $phrase, $ordering, $limit);


        return $return;
    }


	/* search_courses */
   public static function search_categories_parameters() {
        return new external_function_parameters(
                        array(
                            'text' => new external_value(PARAM_TEXT, 'text to search'),
                            'phrase' => new external_value(PARAM_TEXT, 'search type'),
                            'ordering' => new external_value(PARAM_TEXT, 'order'),
                            'limit' => new external_value(PARAM_TEXT, 'limit'),
                        )
        );
    }

    public static function search_categories_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'cat_id' => new external_value(PARAM_INT, 'category id'),
						'cat_name' => new external_value(PARAM_TEXT, 'category name'),
						'cat_description' => new external_value(PARAM_RAW, 'category description'),
					)
				)
            );
    }
    public static function search_categories($text, $phrase, $ordering, $limit) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::search_categories_parameters(), array('text'=>$text, 'phrase'=>$phrase, 'ordering'=>$ordering, 'limit'=>$limit));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->search_categories ($text, $phrase, $ordering, $limit);


        return $return;
    }


	/* search_topics */
   public static function search_topics_parameters() {
        return new external_function_parameters(
                        array(
                            'text' => new external_value(PARAM_TEXT, 'text to search'),
                            'phrase' => new external_value(PARAM_TEXT, 'search type'),
                            'ordering' => new external_value(PARAM_TEXT, 'order'),
                            'limit' => new external_value(PARAM_TEXT, 'limit'),
                        )
        );
    }

    public static function search_topics_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'remoteid' => new external_value(PARAM_INT, 'course id'),
						'fullname' => new external_value(PARAM_TEXT, 'course name'),
						'course' => new external_value(PARAM_TEXT, 'course name'),
						'section' => new external_value(PARAM_TEXT, 'course name'),
						'summary' => new external_value(PARAM_RAW, 'summary'),
						'cat_id' => new external_value(PARAM_INT, 'category id'),
						'cat_name' => new external_value(PARAM_TEXT, 'category name'),
					)
				)
            );
    }
    public static function search_topics($text, $phrase, $ordering, $limit) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::search_topics_parameters(), array('text'=>$text, 'phrase'=>$phrase, 'ordering'=>$ordering, 'limit'=>$limit));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->search_topics ($text, $phrase, $ordering, $limit);


        return $return;
    }

	/* get_my_courses_grades */
    public static function get_my_courses_grades_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'username'),
                        )
        );
    }

    public static function get_my_courses_grades_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'id' => new external_value(PARAM_INT, 'course id'),
						'fullname' => new external_value(PARAM_TEXT, 'course name'),
						'cat_id' => new external_value(PARAM_INT, 'category id'),
						'cat_name' => new external_value(PARAM_TEXT, 'category name'),
						'avg' => new external_value(PARAM_TEXT, 'average grade'),
					)
				)
            );
    }

    public static function get_my_courses_grades($username) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_my_courses_grades_parameters(), array('username'=>$username));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_my_courses_grades ($username);


        return $return;
    }

	/* check_moodle_users */
    public static function check_moodle_users_parameters() {
        return new external_function_parameters(
                        array(
                            'users' => new external_multiple_structure(
										new external_single_structure(
											array(
												'username' => new external_value(PARAM_TEXT, 'username'),
											)
										)
                        )
				)
        );
    }

    public static function check_moodle_users_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'username' => new external_value(PARAM_TEXT, 'username'),
						'admin' => new external_value(PARAM_INT, 'admin user'),
						'auth' => new external_value(PARAM_TEXT, 'auth plugin'),
						'm_account' => new external_value(PARAM_INT, 'moodle account'),
					)
				)
            );
    }

    public static function check_moodle_users($users) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::check_moodle_users_parameters(), array('users'=>$users));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->check_moodle_users ($users);


        return $return;
    }

	/* get_moodle_only_users */
    public static function get_moodle_only_users_parameters() {
        return new external_function_parameters(
                        array(
                            'users' => new external_multiple_structure(
										new external_single_structure(
											array(
												'username' => new external_value(PARAM_TEXT, 'username'),
											)
										)
									),
							'search' => new external_value(PARAM_TEXT, 'sarch text'),
						)
				);
    }

    public static function get_moodle_only_users_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'id' => new external_value(PARAM_INT, 'user id'),
						'username' => new external_value(PARAM_TEXT, 'username'),
						'email' => new external_value(PARAM_TEXT, 'email'),
						'name' => new external_value(PARAM_TEXT, 'name'),
						'auth' => new external_value(PARAM_TEXT, 'auth plugin'),
						'admin' => new external_value(PARAM_INT, 'admin user'),
					)
				)
            );
    }

    public static function get_moodle_only_users($users, $search) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_moodle_only_users_parameters(), array('users'=>$users, 'search' => $search));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_moodle_only_users ($users, $search);


        return $return;
    }

	/* get_moodle_users */
    public static function get_moodle_users_parameters() {
        return new external_function_parameters(
                        array(
							'limitstart' => new external_value(PARAM_INT, 'limit start'),
							'limit' => new external_value(PARAM_INT, 'limit'),
							'order' => new external_value(PARAM_TEXT, 'order'),
							'order_dir' => new external_value(PARAM_TEXT, 'order dir'),
							'search' => new external_value(PARAM_TEXT, 'search text'),
						)
				);
    }

    public static function get_moodle_users_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'id' => new external_value(PARAM_INT, 'user id'),
						'username' => new external_value(PARAM_TEXT, 'username'),
						'email' => new external_value(PARAM_TEXT, 'email'),
						'name' => new external_value(PARAM_TEXT, 'name'),
						'auth' => new external_value(PARAM_TEXT, 'auth plugin'),
						'admin' => new external_value(PARAM_INT, 'admin user'),
					)
				)
            );
    }

    public static function get_moodle_users($limitstart, $limit, $order, $order_dir, $search) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_moodle_users_parameters(), array('limitstart'=>$limitstart, 'limit'=>$limit, 'order'=>$order, 'order_dir'=>$order_dir,'search' => $search));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_moodle_users ($limitstart, $limit, $order, $order_dir, $search);


        return $return;
    }

	/* get_moodle_users_number */
    public static function get_moodle_users_number_parameters() {
        return new external_function_parameters(
                        array(
							'search' => new external_value(PARAM_TEXT, 'sarch text'),
						)
				);
    }

    public static function get_moodle_users_number_returns() {
        return new  external_value(PARAM_INT, 'user number');
    }

    public static function get_moodle_users_number($search) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_moodle_users_number_parameters(), array('search' => $search));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_moodle_users_number ($search);


        return $return;
    }

	/* user_exists */
    public static function user_exists_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'multilang compatible name, course unique'),
                        )
        );
    }

    public static function user_exists_returns() {
        return new  external_value(PARAM_INT, 'whether user exists');
    }

    public static function user_exists($username) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::user_exists_parameters(), array('username'=>$username));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->user_exists ($username);

        return $id;
    }

	/* create_joomdle_user */
    public static function create_joomdle_user_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'username'),
                        )
        );
    }

    public static function create_joomdle_user_returns() {
        return new  external_value(PARAM_INT, 'user created');
    }

    public static function create_joomdle_user($username) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::create_joomdle_user_parameters(), array('username'=>$username));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->create_joomdle_user ($username);

        return $id;
    }

	/* enrol_user */
    public static function enrol_user_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'username'),
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function enrol_user_returns() {
        return new  external_value(PARAM_INT, 'user created');
    }

    public static function enrol_user($username, $id) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::enrol_user_parameters(), array('username'=>$username, 'id' => $id));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->enrol_user ($username, $id);

        return $id;
    }

	/* user_details */
    public static function user_details_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'username'),
                        )
        );
    }

    public static function user_details_returns() {
        return 	new external_single_structure(
					array(
						'username' => new external_value(PARAM_TEXT, 'username'),
						'firstname' => new external_value(PARAM_TEXT, 'firstname'),
						'lastname' => new external_value(PARAM_TEXT, 'lastname'),
						'email' => new external_value(PARAM_TEXT, 'email'),
						'id' => new external_value(PARAM_INT, 'id'),
						'name' => new external_value(PARAM_TEXT, 'name', VALUE_OPTIONAL),
						'city' => new external_value(PARAM_TEXT, 'city', VALUE_OPTIONAL),
						'country' => new external_value(PARAM_TEXT, 'country', VALUE_OPTIONAL),
						'lang' => new external_value(PARAM_TEXT, 'lang', VALUE_OPTIONAL),
						'timezone' => new external_value(PARAM_TEXT, 'timezone', VALUE_OPTIONAL),
						'phone1' => new external_value(PARAM_TEXT, 'phone1', VALUE_OPTIONAL),
						'phone2' => new external_value(PARAM_TEXT, 'phone2', VALUE_OPTIONAL),
						'address' => new external_value(PARAM_TEXT, 'address', VALUE_OPTIONAL),
						'description' => new external_value(PARAM_RAW, 'description', VALUE_OPTIONAL),
						'institution' => new external_value(PARAM_TEXT, 'institution', VALUE_OPTIONAL),
						'url' => new external_value(PARAM_TEXT, 'url', VALUE_OPTIONAL),
						'icq' => new external_value(PARAM_TEXT, 'icq', VALUE_OPTIONAL),
						'skype' => new external_value(PARAM_TEXT, 'skype', VALUE_OPTIONAL),
						'aim' => new external_value(PARAM_TEXT, 'aim', VALUE_OPTIONAL),
						'yahoo' => new external_value(PARAM_TEXT, 'yahoo', VALUE_OPTIONAL),
						'msn' => new external_value(PARAM_TEXT, 'msn', VALUE_OPTIONAL),
						'idnumber' => new external_value(PARAM_TEXT, 'idnumber', VALUE_OPTIONAL),
						'department' => new external_value(PARAM_TEXT, 'department', VALUE_OPTIONAL),
						'picture' => new external_value(PARAM_TEXT, 'picture', VALUE_OPTIONAL),
						'pic_url' => new external_value(PARAM_TEXT, 'pic url', VALUE_OPTIONAL),
						'custom_fields' => new external_multiple_structure(
								new external_single_structure(
									array(
										'id' => new external_value(PARAM_INT, 'field id'),
										'data' => new external_value(PARAM_RAW, 'data')
									)
								)
							)
					)
				);
    }

    public static function user_details($username) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::user_details_parameters(), array('username'=>$username));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->user_details ($username);

        return $id;
    }

	/* user_details_by_id */
    public static function user_details_by_id_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'user id'),
                        )
        );
    }

    public static function user_details_by_id_returns() {
        return 	new external_single_structure(
					array(
						'username' => new external_value(PARAM_TEXT, 'username'),
					)
				);
    }

    public static function user_details_by_id($id) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::user_details_by_id_parameters(), array('id'=>$id));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->user_details_by_id ($id);

        return $id;
    }


   /* migrate_to_joomdle */
    public static function migrate_to_joomdle_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'username')
                        )
        );
    }

    public static function migrate_to_joomdle_returns() {
        return new  external_value(PARAM_BOOL, 'user migrated');
    }
    public static function migrate_to_joomdle($username) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::migrate_to_joomdle_parameters(), array('username'=>$username));
 
        $auth = new  auth_plugin_joomdle ();
        $id = $auth->migrate_to_joomdle ($username);

        return $id;
    }

   /* my_events */
    public static function my_events_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'username'),
							'courses' =>  new external_multiple_structure(
											new external_single_structure(
												array(
													'id' => new external_value(PARAM_INT, 'course id'),
												)
											)
										)
                        )
        );
    }

    public static function my_events_returns() {
		 return new external_multiple_structure(
            new external_single_structure(
                array(
                    'name' => new external_value(PARAM_TEXT, 'event name'),
                    'timestart' => new external_value(PARAM_INT, 'start time'),
                    'courseid' => new external_value(PARAM_INT, 'course id'),
                )
            )
        );
    }
    public static function my_events($username, $courses) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::my_events_parameters(), array('username'=>$username, 'courses' => $courses));
 
        $auth = new  auth_plugin_joomdle ();
        $id = $auth->my_events ($username, $courses);

        return $id;
    }

	/* delete_user */
    public static function delete_user_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'username'),
                        )
        );
    }

    public static function delete_user_returns() {
        return new  external_value(PARAM_BOOL, 'user deleted');
    }

    public static function delete_user($username) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::delete_user_parameters(), array('username'=>$username));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->delete_user ($username);

        return $id;
    }

	/* get_mentees */
    public static function get_mentees_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'username'),
                        )
        );
    }

    public static function get_mentees_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'id' => new external_value(PARAM_INT, 'user id'),
						'username' => new external_value(PARAM_TEXT, 'username'),
						'name' => new external_value(PARAM_TEXT, 'name'),
					)
				)
            );
    }

    public static function get_mentees($username) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_mentees_parameters(), array('username'=>$username));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->get_mentees ($username);

        return $id;
    }


	/* get_roles */
    public static function get_roles_parameters() {
        return new external_function_parameters(
                        array(
                        )
        );
    }

    public static function get_roles_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'id' => new external_value(PARAM_INT, 'role id'),
						'name' => new external_value(PARAM_TEXT, 'role name'),
					)
				)
            );
    }

    public static function get_roles() { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_roles_parameters(), array());
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->get_roles ();

        return $id;
    }

	/* get_parents */
    public static function get_parents_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'username'),
                        )
        );
    }

    public static function get_parents_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'username' => new external_value(PARAM_TEXT, 'username'),
					)
				)
            );
    }

    public static function get_parents($username) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_parents_parameters(), array('username'=>$username));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->get_parents ($username);

        return $id;
    }

	/* get_site_last_week_stats */
    public static function get_site_last_week_stats_parameters() {
        return new external_function_parameters(
                        array(
                        )
        );
    }

    public static function get_site_last_week_stats_returns() {
		 return new external_multiple_structure(
            new external_single_structure(
                array(
                    'stat1' => new external_value(PARAM_INT, 'reads'),
                    'stat2' => new external_value(PARAM_INT, 'writes'),
                )
			)
		);
    }

    public static function get_site_last_week_stats() {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_site_last_week_stats_parameters(), array());
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_site_last_week_stats ();

        return $return;
    }

	/* get_course_daily_stats */
    public static function get_course_daily_stats_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function get_course_daily_stats_returns() {
		 return new external_multiple_structure(
            new external_single_structure(
                array(
                    'stat1' => new external_value(PARAM_INT, 'reads'),
                    'stat2' => new external_value(PARAM_INT, 'writes'),
                    'timeend' => new external_value(PARAM_INT, 'time'),
                )
			)
		);
    }

    public static function get_course_daily_stats($id) {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_course_daily_stats_parameters(), array('id' => $id));
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->get_course_daily_stats ();

        return $return;
    }

	/* get_last_user_grades */
    public static function get_last_user_grades_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'username'),
							'limit' => new external_value(PARAM_INT, 'max items to return'),
                        )
        );
    }

    public static function get_last_user_grades_returns() {
		 return new external_multiple_structure(
				new external_single_structure(
					array(
						'itemname' => new external_value(PARAM_TEXT, 'task name'),
						'finalgrade' => new external_value(PARAM_TEXT, 'grade'),
						'average' => new external_value(PARAM_TEXT, 'average'),
					)
				)
            );
    }

    public static function get_last_user_grades($username, $limit) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_last_user_grades_parameters(), array('username'=>$username, 'limit' => $limit));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->get_last_user_grades ($username, $limit);

        return $id;
    }

	/* system_check */
    public static function system_check_parameters() {
        return new external_function_parameters(
                        array(
                        )
        );
    }

    public static function system_check_returns() {
           return new external_single_structure(
                array(
                    'joomdle_auth' => new external_value(PARAM_INT, 'joomdle plugin enabled'),
                    'mnet_auth' => new external_value(PARAM_INT, 'mnet plugin enabled'),
 //                   'enablewebservices' => new external_value(PARAM_INT, 'webservices enabled'),
                    'joomdle_configured' => new external_value(PARAM_INT, 'joomdle configured'),
                    'test_data' => new external_value(PARAM_RAW, 'test data', VALUE_OPTIONAL),
                )
		);
    }

    public static function system_check() {
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::system_check_parameters(), array());
 
		$auth = new  auth_plugin_joomdle ();
		$return = $auth->system_check ();

        return $return;
    }

	/* add_parent_role */
    public static function add_parent_role_parameters() {
        return new external_function_parameters(
                        array(
                            'child' => new external_value(PARAM_TEXT, 'child username'),
                            'parent' => new external_value(PARAM_TEXT, ' parent username'),
                        )
        );
    }

    public static function add_parent_role_returns() {
        return new  external_value(PARAM_TEXT, 'role added');
    }

    public static function add_parent_role($child, $parent) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::add_parent_role_parameters(), array('child'=>$child, 'parent' => $parent));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->add_parent_role ($child, $parent);

        return $id;
    }

	/* get_paypal_config */
    public static function get_paypal_config_parameters() {
        return new external_function_parameters(
                        array(
                        )
        );
    }

    public static function get_paypal_config_returns() {
        return 	new external_single_structure(
					array(
						'paypalurl' => new external_value(PARAM_TEXT, 'paypal url'),
						'paypalbusiness' => new external_value(PARAM_TEXT, 'paypal email'),
					)
				);
    }

    public static function get_paypal_config() { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_paypal_config_parameters(), array());
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->get_paypal_config ();

        return $id;
    }

	/* update_session */
    public static function update_session_parameters() {
        return new external_function_parameters(
                        array(
                            'session_id' => new external_value(PARAM_TEXT, 'session id'),
                        )
        );
    }

    public static function update_session_returns() {
        return new  external_value(PARAM_BOOL, 'user migrated');
    }

    public static function update_session($session_id) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::update_session_parameters(), array('session_id'=>$session_id));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->update_session ($session_id);

        return $id;
    }

	/* get_cat_name */
    public static function get_cat_name_parameters() {
        return new external_function_parameters(
                        array(
                            'cat_id' => new external_value(PARAM_INT, 'category id'),
                        )
        );
    }

    public static function get_cat_name_returns() {
        return new  external_value(PARAM_TEXT, 'category name');
    }

    public static function get_cat_name($cat_id) { 
        global $CFG, $DB;
 
        $params = self::validate_parameters(self::get_cat_name_parameters(), array('cat_id'=>$cat_id));
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->get_cat_name ($cat_id);

        return $id;
    }

	/* courses_abc */
    public static function courses_abc_parameters() {
        return new external_function_parameters(
                        array(
                            'start_chars' => new external_value(PARAM_TEXT, 'Start chars'),
                        )
        );
    }

    public static function courses_abc_returns() {
		 return new external_multiple_structure(
            new external_single_structure(
                array(
                    'remoteid' => new external_value(PARAM_INT, 'course id'),
                    'cat_id' => new external_value(PARAM_INT, 'category id'),
                    'cat_name' => new external_value(PARAM_TEXT, 'cartegory name'),
                    'cat_description' => new external_value(PARAM_RAW, 'category description'),
                    'sortorder' => new external_value(PARAM_TEXT, 'sortorder'),
                    'fullname' => new external_value(PARAM_TEXT, 'course name'),
                    'shortname' => new external_value(PARAM_TEXT, 'course shortname'),
                    'idnumber' => new external_value(PARAM_RAW, 'idnumber'),
                    'summary' => new external_value(PARAM_RAW, 'summary'),
                    'startdate' => new external_value(PARAM_INT, 'start date'),
                    'created' => new external_value(PARAM_INT, 'created'),
                    'modified' => new external_value(PARAM_INT, 'modified'), 
                )
            )
        );
    }

    public static function courses_abc($start_chars) { //Don't forget to set it as static
        global $CFG, $DB;
 
      $params = self::validate_parameters(self::courses_abc_parameters(), array('start_chars' => $start_chars)); 
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->courses_abc ($start_chars);

        return $id;
    }

	/* teachers_abc */
    public static function teachers_abc_parameters() {
        return new external_function_parameters(
                        array(
                            'start_chars' => new external_value(PARAM_TEXT, 'Start chars'),
                        )
        );
    }

    public static function teachers_abc_returns() {
		 return new external_multiple_structure(
            new external_single_structure(
                array(
						'firstname' => new external_value(PARAM_TEXT, 'firstname'),
						'lastname' => new external_value(PARAM_TEXT, 'lastname'),
						'username' => new external_value(PARAM_TEXT, 'username'),
                )
            )
        );
    }

    public static function teachers_abc($start_chars) { 
        global $CFG, $DB;
 
      $params = self::validate_parameters(self::teachers_abc_parameters(), array('start_chars' => $start_chars)); 
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->teachers_abc ($start_chars);

        return $id;
    }

	/* teacher_courses */
    public static function teacher_courses_parameters() {
        return new external_function_parameters(
                        array(
                            'username' => new external_value(PARAM_TEXT, 'Teacher username'),
                        )
        );
    }

    public static function teacher_courses_returns() {
		 return new external_multiple_structure(
            new external_single_structure(
                array(
						'remoteid' => new external_value(PARAM_INT, 'course id'),
						'fullname' => new external_value(PARAM_TEXT, 'course name'),
						'cat_id' => new external_value(PARAM_INT, 'category id'),
						'cat_name' => new external_value(PARAM_TEXT, 'category name'),
                )
            )
        );
    }

    public static function teacher_courses($username) { 
        global $CFG, $DB;
 
      $params = self::validate_parameters(self::teacher_courses_parameters(), array('username' => $username)); 
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->teacher_courses ($username);

        return $id;
    }

	/* user_custom_fields */
    public static function user_custom_fields_parameters() {
        return new external_function_parameters(
                        array(
                        )
        );
    }

    public static function user_custom_fields_returns() {
		 return new external_multiple_structure(
            new external_single_structure(
                array(
						'id' => new external_value(PARAM_INT, 'field id'),
						'name' => new external_value(PARAM_TEXT, 'field name'),
                )
            )
        );
    }

    public static function user_custom_fields() { 
        global $CFG, $DB;
 
      $params = self::validate_parameters(self::user_custom_fields_parameters(), array()); 
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->user_custom_fields ();

        return $id;
    }

	/* course_enrol_methods */
    public static function course_enrol_methods_parameters() {
        return new external_function_parameters(
                        array(
                            'id' => new external_value(PARAM_INT, 'course id'),
                        )
        );
    }

    public static function course_enrol_methods_returns() {
		 return new external_multiple_structure(
            new external_single_structure(
                array(
						'id' => new external_value(PARAM_INT, 'enrol method id'),
						'enrol' => new external_value(PARAM_TEXT, 'enrol method name'),
						'enrolstartdate' => new external_value(PARAM_INT, 'enrol start date', VALUE_OPTIONAL), 
						'enrolenddate' => new external_value(PARAM_INT, 'enrol end date', VALUE_OPTIONAL), 
                )
            )
        );
    }

    public static function course_enrol_methods($id) { 
        global $CFG, $DB;
 
      $params = self::validate_parameters(self::course_enrol_methods_parameters(), array('id' => $id)); 
 
		$auth = new  auth_plugin_joomdle ();
		$id = $auth->course_enrol_methods ($id);

        return $id;
    }

}
?>
