<?php
/**
* @author Antonio Duran
* @email antonio.duran.terres@gmail.com
* @package Joomdle
* @license GNU/GPL
* @description Xmap plugin for Joomdle component
*/

defined( '_VALID_MOS' ) or defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomdle'.DS.'helpers'.DS.'content.php');


/** Adds support for Virtuemart categories to Xmap */
class xmap_com_joomdle {

	/*
	* This function is called before a menu item is printed. We use it to set the
	* proper uniqueid for the item and indicate whether the node is expandible or not
	*/
	function prepareMenuItem(&$node) {
		$link_query = parse_url( $node->link );
		parse_str( html_entity_decode($link_query['query']), $link_vars);
		$view = JArrayHelper::getValue($link_vars,'view','');

		switch ($view)
		{
			case 'detail': //XXX esoto no se pa ke vale
				$id = intval(JArrayHelper::getValue($link_vars,'course_id',0));
				if ( $id ) {
					$node->uid = 'com_joomdled'.$id;
					$node->expandible = false;
				}
				break;
			case 'coursecategories':
				$node->uid = 'com_joomdlecc';
				$node->expandible = true;
				break;
			case 'joomdle':
				$node->uid = 'com_joomdlej';
				$node->expandible = true;
				break;
			default:
				$node->expandible = false;
		}
	}

	/** Get the content tree for this kind of content */
	function getTree( &$xmap, &$parent, &$params ) {

		$catid = 0;
		$params['Itemid'] = $parent->id;


		$result = null;

                $link_query = parse_url( $parent->link );
                parse_str( html_entity_decode($link_query['query']), $link_vars);
                $view = JArrayHelper::getValue($link_vars,'view','');
                $id = intval(JArrayHelper::getValue($link_vars,'id',0));

                $menu =& JSite::getMenu();
                $menuparams = $menu->getParams($parent->id);

                /***
                * Parameters Initialitation
                **/
                //----- Set expand_categories param
                $expand_categories = JArrayHelper::getValue($params,'expand_categories',1);
                $expand_categories = ( $expand_categories == 1
                                  || ( $expand_categories == 2 && $xmap->view == 'xml')
                                  || ( $expand_categories == 3 && $xmap->view == 'html')
                                                                  ||   $xmap->view == 'navigator');
                $params['expand_categories'] = $expand_categories;

		//----- Set cat_priority and cat_changefreq params
                $priority = JArrayHelper::getValue($params,'cat_priority',$parent->priority);
                $changefreq = JArrayHelper::getValue($params,'cat_changefreq',$parent->changefreq);
                if ($priority  == '-1')
                        $priority = $parent->priority;
                if ($changefreq  == '-1')
                        $changefreq = $parent->changefreq;

                $params['cat_priority'] = $priority;
                $params['cat_changefreq'] = $changefreq;

                //----- Set course_priority and course_changefreq params
                $priority = JArrayHelper::getValue($params,'course_priority',$parent->priority);
                $changefreq = JArrayHelper::getValue($params,'course_changefreq',$parent->changefreq);
                if ($priority  == '-1')
                        $priority = $parent->priority;
                if ($changefreq  == '-1')
                        $changefreq = $parent->changefreq;

                $params['course_priority'] = $priority;
                $params['course_changefreq'] = $changefreq;


		switch ($view)
		{
			case 'coursecategories':
			case 'coursesbycategory':
				xmap_com_joomdle::getCategoryTree($xmap, $parent, $params, $catid);
				break;
			case 'joomdle':
				xmap_com_joomdle::getCourseTree($xmap, $parent, $params, 0);
				break;
			default:
				/* Don't show anything for other views */
				break;
		}
		return true;
	}

	/** Joomdle support */
	function &getCategoryTree( &$xmap, &$parent,&$params, $catid=0 ) {
		$database = &JFactory::getDBO();
		global $sess;

		$itemid = $params['Itemid'];
		$cats =  JoomdleHelperContent::getCourseCategories ($catid);

		if (!$cats)
			return $list;

		$xmap->changeLevel(1);
		foreach($cats as $cat) {
			$node = new stdclass;

			$node->id = $params['Itemid'];
			$node->id = $parent->id;
			$node->uid = $parent->uid.'c'.$cat['id'];
			$node->browserNav = $parent->browserNav;
			$node->name = stripslashes($cat['name']);
			$node->modified = intval($cat['timemodified']);
			$node->priority = $params['cat_priority'];
			$node->changefreq = $params['cat_changefreq'];
			$node->expandible = true;
			$itemid = $parent->id;
			$node->link = JRoute::_("index.php?option=com_joomdle&view=coursecategory&cat_id=".$cat['id'].':'.JFilterOutput::stringURLSafe($cat['name'])."&Itemid=$itemid"); 
			$xmap->printNode($node);


			xmap_com_joomdle::getCategoryTree( $xmap, $parent, $params, $cat['id']);
			if( $params['expand_categories'] )
				xmap_com_joomdle::getCourseCategoryTree( $xmap, $parent, $params, $cat['id']);
		    //	if ($xmap->printNode($node) !== FALSE) {
		//		xmap_com_joomdle::getCategoryTree( $xmap, $parent, $params, $row->category_id);
		//	}
	    	}
		$xmap->changeLevel(-1);

		return $list;
	}

	function &getCourseTree( &$xmap, &$parent,&$params, $catid=0 ) {
		$database = &JFactory::getDBO();
		global $sess;

		$itemid = $params['Itemid'];
		$courses =  JoomdleHelperContent::getCourseList (0);

		if (!$courses)
			return $list;


		$xmap->changeLevel(1);
		foreach($courses as $course) {
			$node = new stdclass;

			$node->id = $params['Itemid'];
			$node->uid = $parent->uid.'c'.$course['remoteid'];
			$node->browserNav = $parent->browserNav;
			$node->name = stripslashes($course['fullname']);
			$node->modified = intval($course['modified']);
			$node->priority = $params['course_priority'];
			$node->changefreq = $params['course_changefreq'];
			$node->expandible = true;

			$cat_id = $course['cat_id'];
			$course_id = $course['remoteid'];
			$cat_slug = JFilterOutput::stringURLSafe ($course['cat_name']);
			$course_slug = JFilterOutput::stringURLSafe ($course['fullname']);

			$node->link = JRoute::_("index.php?option=com_joomdle&view=detail&cat_id=$cat_id:$cat_slug&course_id=$course_id:$course_slug&Itemid=$itemid");
			$xmap->printNode($node);

		    //	if ($xmap->printNode($node) !== FALSE) {
		//		xmap_com_joomdle::getCategoryTree( $xmap, $parent, $params, $row->category_id);
		//	}
	    	}
		$xmap->changeLevel(-1);

		return $list;
	}

	function &getCourseCategoryTree( &$xmap, &$parent,&$params, $catid=0 ) {
		$database = &JFactory::getDBO();
		global $sess;

		$itemid = $params['Itemid'];
		$courses =  JoomdleHelperContent::getCourseCategory ($catid);

		if (!$courses)
			return $list;

		$xmap->changeLevel(1);
		foreach($courses as $course) {
			$node = new stdclass;

			$node->id = $params['Itemid'];
			$node->uid = $parent->uid.'c'.$course['remoteid'];
			$node->browserNav = $parent->browserNav;
			$node->name = stripslashes($course['fullname']);
			$node->modified = intval($course['modified']);
			$node->priority = $params['course_priority'];
			$node->changefreq = $params['course_changefreq'];
			$node->expandible = true;

			$cat_id = $course['cat_id'];
			$course_id = $course['remoteid'];
			$cat_slug = JFilterOutput::stringURLSafe ($course['cat_name']);
			$course_slug = JFilterOutput::stringURLSafe ($course['fullname']);

			$node->link = JRoute::_("index.php?option=com_joomdle&view=detail&cat_id=$cat_id:$cat_slug&course_id=$course_id:$course_slug&Itemid=$itemid");
			$xmap->printNode($node);

		    //	if ($xmap->printNode($node) !== FALSE) {
		//		xmap_com_joomdle::getCategoryTree( $xmap, $parent, $params, $row->category_id);
		//	}
	    	}
		$xmap->changeLevel(-1);

		return $list;
	}
}
